(in-package #:org.shirakumo.fraf.trial.nxgl)

(define-global +scan-code-keyword-map+
    (let ((table (make-hash-table :test 'eql)))
      (loop for (k v) in '(((:UNKNOWN 0)
                            (:A 4)
                            (:B 5)
                            (:C 6)
                            (:D 7)
                            (:E 8)
                            (:F 9)
                            (:G 10)
                            (:H 11)
                            (:I 12)
                            (:J 13)
                            (:K 14)
                            (:L 15)
                            (:M 16)
                            (:N 17)
                            (:O 18)
                            (:P 19)
                            (:Q 20)
                            (:R 21)
                            (:S 22)
                            (:T 23)
                            (:U 24)
                            (:V 25)
                            (:W 26)
                            (:X 27)
                            (:Y 28)
                            (:Z 29)
                            (:1 30)
                            (:2 31)
                            (:3 32)
                            (:4 33)
                            (:5 34)
                            (:6 35)
                            (:7 36)
                            (:8 37)
                            (:9 38)
                            (:0 39)
                            (:RETURN 40)
                            (:ESCAPE 41)
                            (:BACKSPACE 42)
                            (:TAB 43)
                            (:SPACE 44)
                            (:MINUS 45)
                            (:EQUALS 46)
                            (:LEFTBRACKET 47)
                            (:RIGHTBRACKET 48)
                            (:BACKSLASH 49)
                            (:NONUSHASH 50)
                            (:SEMICOLON 51)
                            (:APOSTROPHE 52)
                            (:GRAVE 53)
                            (:COMMA 54)
                            (:PERIOD 55)
                            (:SLASH 56)
                            (:CAPSLOCK 57)
                            (:F1 58)
                            (:F2 59)
                            (:F3 60)
                            (:F4 61)
                            (:F5 62)
                            (:F6 63)
                            (:F7 64)
                            (:F8 65)
                            (:F9 66)
                            (:F10 67)
                            (:F11 68)
                            (:F12 69)
                            (:PRINTSCREEN 70)
                            (:SCROLLLOCK 71)
                            (:PAUSE 72)
                            (:INSERT 73)
                            (:HOME 74)
                            (:PAGEUP 75)
                            (:DELETE 76)
                            (:END 77)
                            (:PAGEDOWN 78)
                            (:RIGHT 79)
                            (:LEFT 80)
                            (:DOWN 81)
                            (:UP 82)
                            (:NUMLOCKCLEAR 83)
                            (:KP-DIVIDE 84)
                            (:KP-MULTIPLY 85)
                            (:KP-MINUS 86)
                            (:KP-PLUS 87)
                            (:KP-ENTER 88)
                            (:KP-1 89)
                            (:KP-2 90)
                            (:KP-3 91)
                            (:KP-4 92)
                            (:KP-5 93)
                            (:KP-6 94)
                            (:KP-7 95)
                            (:KP-8 96)
                            (:KP-9 97)
                            (:KP-0 98)
                            (:KP-PERIOD 99)
                            (:NONUSBACKSLASH 100)
                            (:APPLICATION 101)
                            (:KP-EQUALS 103)
                            (:F13 104)
                            (:F14 105)
                            (:F15 106)
                            (:F16 107)
                            (:F17 108)
                            (:F18 109)
                            (:F19 110)
                            (:F20 111)
                            (:F21 112)
                            (:F22 113)
                            (:F23 114)
                            (:F24 115)
                            (:EXECUTE 116)
                            (:HELP 117)
                            (:MENU 118)
                            (:SELECT 119)
                            (:STOP 120)
                            (:AGAIN 121)
                            (:UNDO 122)
                            (:CUT 123)
                            (:COPY 124)
                            (:PASTE 125)
                            (:FIND 126)
                            (:MUTE 127)
                            (:VOLUMEUP 128)
                            (:VOLUMEDOWN 129)
                            (:KP-COMMA 133)
                            (:KP-EQUALSAS400 134)
                            (:INTERNATIONAL1 135)
                            (:INTERNATIONAL2 136)
                            (:INTERNATIONAL3 137)
                            (:INTERNATIONAL4 138)
                            (:INTERNATIONAL5 139)
                            (:INTERNATIONAL6 140)
                            (:INTERNATIONAL7 141)
                            (:INTERNATIONAL8 142)
                            (:INTERNATIONAL9 143)
                            (:LANG1 144)
                            (:LANG2 145)
                            (:LANG3 146)
                            (:LANG4 147)
                            (:LANG5 148)
                            (:LANG6 149)
                            (:LANG7 150)
                            (:LANG8 151)
                            (:LANG9 152)
                            (:ALTERASE 153 )
                            (:SYSREQ 154)
                            (:CANCEL 155)
                            (:CLEAR 156)
                            (:PRIOR 157)
                            (:RETURN2 158)
                            (:SEPARATOR 159)
                            (:OUT 160)
                            (:OPER 161)
                            (:CLEARAGAIN 162)
                            (:CRSEL 163)
                            (:EXSEL 164)
                            (:KP-00 176)
                            (:KP-000 177)
                            (:THOUSANDSSEPARATOR 178)
                            (:DECIMALSEPARATOR 179)
                            (:CURRENCYUNIT 180)
                            (:CURRENCYSUBUNIT 181)
                            (:KP-LEFTPAREN 182)
                            (:KP-RIGHTPAREN 183)
                            (:KP-LEFTBRACE 184)
                            (:KP-RIGHTBRACE 185)
                            (:KP-TAB 186)
                            (:KP-BACKSPACE 187)
                            (:KP-A 188)
                            (:KP-B 189)
                            (:KP-C 190)
                            (:KP-D 191)
                            (:KP-E 192)
                            (:KP-F 193)
                            (:KP-XOR 194)
                            (:KP-POWER 195)
                            (:KP-PERCENT 196)
                            (:KP-LESS 197)
                            (:KP-GREATER 198)
                            (:KP-AMPERSAND 199)
                            (:KP-DBLAMPERSAND 200)
                            (:KP-VERTICALBAR 201)
                            (:KP-DBLVERTICALBAR 202)
                            (:KP-COLON 203)
                            (:KP-HASH 204)
                            (:KP-SPACE 205)
                            (:KP-AT 206)
                            (:KP-EXCLAM 207)
                            (:KP-MEMSTORE 208)
                            (:KP-MEMRECALL 209)
                            (:KP-MEMCLEAR 210)
                            (:KP-MEMADD 211)
                            (:KP-MEMSUBTRACT 212)
                            (:KP-MEMMULTIPLY 213)
                            (:KP-MEMDIVIDE 214)
                            (:KP-PLUSMINUS 215)
                            (:KP-CLEAR 216)
                            (:KP-CLEARENTRY 217)
                            (:KP-BINARY 218)
                            (:KP-OCTAL 219)
                            (:KP-DECIMAL 220)
                            (:KP-HEXADECIMAL 221)
                            (:LCTRL 224)
                            (:LSHIFT 225)
                            (:LALT 226)
                            (:LGUI 227)
                            (:RCTRL 228)
                            (:RSHIFT 229)
                            (:RALT 230)
                            (:RGUI 231)
                            (:MODE 257)
                            (:AUDIONEXT 258)
                            (:AUDIOPREV 259)
                            (:AUDIOSTOP 260)
                            (:AUDIOPLAY 261)
                            (:AUDIOMUTE 262)
                            (:MEDIASELECT 263)
                            (:WWW 264)
                            (:MAIL 265)
                            (:CALCULATOR 266)
                            (:COMPUTER 267)
                            (:AC-SEARCH 268)
                            (:AC-HOME 269)
                            (:AC-BACK 270)
                            (:AC-FORWARD 271)
                            (:AC-STOP 272)
                            (:AC-REFRESH 273)
                            (:AC-BOOKMARKS 274)
                            (:BRIGHTNESSDOWN 275)
                            (:BRIGHTNESSUP 276)
                            (:DISPLAYSWITCH 277)
                            (:KBDILLUMTOGGLE 278)
                            (:KBDILLUMDOWN 279)
                            (:KBDILLUMUP 280)
                            (:EJECT 281)
                            (:SLEEP 282)
                            (:APP1 283)
                            (:APP2 284)
                            (:AUDIOREWIND 285)
                            (:AUDIOFASTFORWARD 286)))
            do (setf (gethash v table) k))
      table))

(defun button->keyword (button)
  (case button
    (0 :left)
    (1 :right)
    (2 :middle)
    (3 :x1)
    (4 :x2)
    (T :x3)))

(defun scan-code->keyword (code)
  (gethash code +scan-code-keyword-map+ code))
